# 製品コンテキスト: sgmap

## 解決する問題

AWS のセキュリティグループは、インスタンスやリソースへのトラフィックを制御するための重要なセキュリティ機能です。しかし、複雑なインフラストラクチャでは、多数のセキュリティグループとその相互接続関係を把握することが困難になります。特に以下のような課題があります：

1. **可視性の欠如**: AWS コンソールでは、セキュリティグループ間の接続関係を視覚的に把握することが難しい
2. **複雑な依存関係**: 多数のセキュリティグループが存在する環境では、どのグループがどのグループと通信できるかを理解するのが困難
3. **セキュリティ監査の複雑さ**: セキュリティ設定の監査や最適化を行う際に、全体像を把握することが難しい

sgmap は、これらの問題を解決するために、セキュリティグループの接続関係を視覚的に表現し、理解しやすい形で提供します。

## 機能の詳細

### VPC 単位での分析

AWS のセキュリティグループは VPC 内で機能するため、VPC ID を必須パラメータとして、その VPC 内のセキュリティグループを分析します。これにより、特定の VPC 内のセキュリティ設定に焦点を当てた分析が可能になります。

### セキュリティグループのフィルタリング

特定のセキュリティグループに関連する接続のみを分析したい場合に、セキュリティグループ ID を指定してフィルタリングできます。これにより、関心のあるセキュリティグループに焦点を当てた分析が可能になります。

### 視覚化と構造化データ

- **mermaid 記法**: セキュリティグループ間の接続関係をフローチャートとして視覚的に表現します。これにより、接続の方向性やプロトコル、ポート情報を一目で把握できます。
- **JSON 出力**: プログラムによる処理や他のツールとの連携のために、構造化された JSON 形式でのデータ出力も提供します。

## ユーザー体験の目標

1. **シンプルさ**: 最小限のパラメータで必要な情報を取得できるシンプルなインターフェース
2. **明確さ**: セキュリティグループの接続関係を明確に理解できる視覚的な表現
3. **効率性**: コマンド一つで複雑なセキュリティグループの関係を分析できる効率的なツール
4. **柔軟性**: 異なる出力形式や分析範囲を選択できる柔軟なオプション

## 想定されるユースケース

1. **インフラストラクチャの理解**: 既存の AWS 環境のセキュリティグループ設定を理解する
2. **セキュリティ監査**: セキュリティグループの設定が意図した通りになっているかを確認する
3. **トラブルシューティング**: 接続問題が発生した際に、セキュリティグループの設定を確認する
4. **ドキュメント作成**: インフラストラクチャのドキュメントを作成する際に、セキュリティグループの関係図を生成する
5. **最適化**: 不要な接続や重複した設定を特定し、セキュリティグループの設定を最適化する
